unit UJoueurs;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls, ComCtrls, Buttons;

type
  TFrmJoueurs = class(TForm)
    GBJetonsRouge: TGroupBox;
    GBJetonsJaune: TGroupBox;
    NomJoueurRouge: TEdit;
    lblJoueurRouge: TLabel;
    lblJoueurJaune: TLabel;
    NomJoueurJaune: TEdit;
    CbGaucheRouge: TComboBox;
    CbValiderRouge: TComboBox;
    CbDroiteRouge: TComboBox;
    CbGaucheJaune: TComboBox;
    CbDroiteJaune: TComboBox;
    CbValiderJaune: TComboBox;
    rbSourisRouge: TRadioButton;
    rbClavierRouge: TRadioButton;
    lblDeplacementRouge: TLabel;
    lblDroiteRouge: TLabel;
    lblGaucheRouge: TLabel;
    lblValiderRouge: TLabel;
    lblDeplacementJaune: TLabel;
    RbSourisJaune: TRadioButton;
    RbClavierJaune: TRadioButton;
    lblGaucheJaune: TLabel;
    lblValiderJaune: TLabel;
    lblDroiteJaune: TLabel;
    BtnOk: TBitBtn;
    BtnAnnuler: TBitBtn;
    procedure BtnOkClick(Sender: TObject);
    procedure BtnAnnulerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
    procedure Enregistre;
    function getItem(combo : TCombobox; chaine : string) : integer;
  public
    { Dclarations publiques }
    constructor CreateFrm(test:TComponent;
            NomJoueurRouge, NomJoueurJaune:String;
            DeplacementSourisRouge, DeplacementSourisJaune : boolean;
            KeyGaucheRouge, KeyValideRouge, KeyDroiteRouge : Integer;
            KeyGaucheJaune, KayValideJaune, KeyDroiteJaune : Integer);
  end;

var
  FrmJoueurs: TFrmJoueurs;
  JoueurRouge, JoueurJaune : string;
  SourisRouge, SourisJaune : boolean;
  KeyGaucheR, KeyValideR, KeyDroiteR : Integer;
  KeyGaucheJ, KeyValideJ, KeyDroiteJ : Integer;

implementation
uses
  main;
{$R *.dfm}

{------------------------------------------------------------------------------
  Constructeur du formulaire
-------------------------------------------------------------------------------}
constructor TFrmJoueurs.CreateFrm(test:TComponent;
            NomJoueurRouge, NomJoueurJaune:String;
            DeplacementSourisRouge, DeplacementSourisJaune : boolean;
            KeyGaucheRouge, KeyValideRouge, KeyDroiteRouge : Integer;
            KeyGaucheJaune, KayValideJaune, KeyDroiteJaune : Integer);
begin
  // information concernant le formulaire appelant
  JoueurRouge := NomJoueurRouge;
  JoueurJaune := NomJoueurJaune;
  SourisRouge := DeplacementSourisRouge;
  SourisJaune := DeplacementSourisJaune;
  KeyGaucheR := KeyGaucheRouge;
  KeyValideR := KeyValideRouge;
  KeyDroiteR := KeyDroiteRouge;
  KeyGaucheJ := KeyGaucheJaune;
  KeyValideJ := KayValideJaune;
  KeyDroiteJ := KeyDroiteJaune;
  // cration du formulaire
  self.Create(test);
end;

{------------------------------------------------------------------------------
  Bouton qui ferme le formulaire
-------------------------------------------------------------------------------}
procedure TFrmJoueurs.BtnAnnulerClick(Sender: TObject);
begin
  // fermeture du formulaire
  self.Close;
end;

{------------------------------------------------------------------------------
  Bouton qui valide les modifications effectu dans le formulaire
-------------------------------------------------------------------------------}
procedure TFrmJoueurs.BtnOkClick(Sender: TObject);
begin
  // sauvegarde les informations
  Enregistre;
  // fermeture du formulaire
  self.Close;
end;

{------------------------------------------------------------------------------
  Exporte les modifications dans le formulaire main
-------------------------------------------------------------------------------}
procedure TFrmJoueurs.Enregistre;
begin
  // Change le nom des joueurs
  FrmMain.SetJoueurRouge(NomJoueurRouge.Text);
  FrmMain.SetJoueurJaune(NomJoueurJaune.Text);
  // joueur en rouge
  if RbSourisRouge.Checked then
    // le deplacement se fait avec la souris
    FrmMain.SetDeplacementSourisRouge(true)
  else
  begin
    // le deplacement ne se fait pas avec la souris
    FrmMain.SetDeplacementSourisRouge(false);
    // renvoie le premier caractere
    FrmMain.SetToucheRouge(ord(CbGaucheRouge.Text[1]), ord(CbValiderRouge.Text[1]), ord(CbDroiteRouge.Text[1]));
  end;
  // joueur en jaune
  if RbSourisJaune.Checked then
    // le deplacement se fait avec la souris
    FrmMain.SetDeplacementSourisJaune(true)
  else
  begin
    // le deplacement ne se fait pas avec la souris
    FrmMain.SetDeplacementSourisJaune(false);
    // renvoie le premier caractere
    FrmMain.SetToucheJaune(ord(CbGaucheJaune.Text[1]), ord(CbValiderJaune.Text[1]), ord(CbDroiteJaune.Text[1]));
  end;

end;

{------------------------------------------------------------------------------
  renvoie le numro d'item dans un TCombobox pour le mot pass en paramtre
-------------------------------------------------------------------------------}
function TFrmJoueurs.getItem(combo : TCombobox; chaine : string) : integer;
var i: integer;
begin
  result := combo.ItemIndex;
  i := 0;
  // recherche le texte dans la TCombobox
  repeat
    if combo.Items[i] = chaine then
      result := i;
    i := i + 1;
  until (result <> combo.ItemIndex) or (i >= combo.Items.Count);
end;

{------------------------------------------------------------------------------
  Cration du formulaire
-------------------------------------------------------------------------------}
procedure TFrmJoueurs.FormCreate(Sender: TObject);
begin
  // affiche le nom des joueurs
  self.NomJoueurRouge.Text := JoueurRouge;
  self.NomJoueurJaune.Text := JoueurJaune;
  // enclenche le bouton radio pour le joueur en rouge
  if SourisRouge then
    self.RbSourisRouge.Checked := true
  else
  begin
    self.RbClavierRouge.Checked := true;
    self.CbGaucheRouge.ItemIndex := getItem(self.cbgaucherouge, chr(KeyGaucheR));
    self.CbValiderRouge.ItemIndex := getitem(self.CbValiderRouge, chr(KeyValideR));
    self.CbDroiteRouge.ItemIndex := getitem(self.CbDroiteRouge, chr(KeyDroiteR));
  end;
  // enclenche le bouton radio pour le joueur en jaune
  if SourisJaune then
    self.RbSourisJaune.Checked := true
  else
  begin
    self.RbClavierJaune.Checked := true;
    self.CbGaucheJaune.ItemIndex := getItem(self.CbGaucheJaune, chr(KeyGaucheJ));
    self.CbValiderJaune.ItemIndex := getItem(self.CbValiderJaune, chr(KeyValideJ));
    self.CbDroiteJaune.ItemIndex := getItem(self.CbDroiteJaune, chr(KeyDroiteJ));
  end;
end;

end.
