unit UVerifVictoire;

INTERFACE

USES Graphics;

FUNCTION TestHorizontal(posx,posy:Byte; curcolor:TColor; NbColonne:Byte):Boolean;
FUNCTION TestVertical(posx, posy:Byte; curcolor:TColor; NbLigne:Byte):Boolean;
FUNCTION TestDiag1(posx,posy:Byte; curcolor:TColor; NbLigne, NbColonne:Byte):Boolean;
FUNCTION TestDiag2(posx,posy:Byte; curcolor:TColor; NbLigne, NbColonne:Byte):Boolean;

IMPLEMENTATION
uses
  MAIN;

{------------------------------------------------------------------------------
  TEST HORIZONTAL
{------------------------------------------------------------------------------}
FUNCTION TestHorizontal(posx,posy:Byte; curcolor:TColor; NbColonne:Byte):Boolean;
VAR
  nb, i:integer;
BEGIN
  nb := 1;
  // Compte le nombre de jeton ayant la meme couleur a gauche de la position
  if posx > 0 then
  begin
    i := posx-1;
    while (frmmain.GetCouleurJeton(i,posy) = curcolor) do
    begin
      nb:=nb+1;
      frmmain.SauvegardeAlignement(i, posy, nb);
      i := i - 1;
      if i < 0 then break;
    end;
  end;
  // Compte le nombre de jeton ayant la meme couleur a droite de la position
  if posx < NbColonne-1 then
  begin
    i := posx+1;
    while (frmmain.GetCouleurJeton(i,posy) = curcolor) do
    begin
      nb := nb + 1;
      frmmain.SauvegardeAlignement(i, posy, nb);
      i := i + 1;
      if i > NbColonne - 1 then break;
    end;
  end;

  IF(nb>=4)THEN Result:=True
          else result := false;
END;

{------------------------------------------------------------------------------
  TEST VERTICAL
-------------------------------------------------------------------------------}
function TestVertical(posx, posy:Byte; curcolor:TColor; NbLigne:Byte):Boolean;
var
  nb, i:integer;
BEGIN
  result := false;
  // verifie que la position vertical est superieur a 3
  if (posy < NbLigne-3) then
  begin
    nb := 1;  // Correspond au jeton qui vient d'tre jou
    // Compte le nombre de jeton ayant la meme couleur au dessus de la position
    if posy>0 then
    begin
      i := posy-1;
      while (frmmain.GetCouleurJeton(posx,i) = curcolor) do
      begin
        nb:=nb+1;
        frmmain.SauvegardeAlignement(posx, i, nb);
        i := i - 1;
        if i < 0 then break;
      end;
    end;
    // Compte le nombre de jeton ayant la meme couleur en dessous de la position
    if posy < NbLigne-1 then
    begin
      i := posy+1;
     while (frmmain.GetCouleurJeton(posx,i) = curcolor) do
      begin
        nb := nb + 1;
        frmmain.SauvegardeAlignement(posx, i, nb);
        i := i + 1;
        if i > NbLigne - 1 then break;
      end;
    end;

    IF(nb>=4)THEN Result:=True
            else result := false;
  end;
END;

{------------------------------------------------------------------------------
  TEST DIAGONAL 1 (\)
-------------------------------------------------------------------------------}
FUNCTION TestDiag1(posx,posy:Byte; curcolor:TColor; NbLigne, NbColonne:Byte):Boolean;
VAR nb,i:byte;
BEGIN
  nb := 1;
  // Compte le nombre de jeton ayant la meme couleur dans le sans descendent
  if (posy < NbLigne-1) and (posx < NbColonne-1) then
  begin
    i := 1;
    while (frmmain.GetCouleurJeton(posx+i,posy+i) = curcolor) do
    begin
      nb := nb + 1;
      frmmain.SauvegardeAlignement(posx+i, posy+i, nb);
      i := i + 1;
      if (posy+i > NbLigne - 1) or (posx+i>NbColonne -1) then break;
    end;
  end;
  // Compte le nombre de jeton ayant la meme couleur dans le sens montant
  if (posy>0) and (posx>0) then
  begin
    i := 1;
    while (frmmain.GetCouleurJeton(posx-i,posy-i) = curcolor) do
    begin
      nb:=nb+1;
      frmmain.SauvegardeAlignement(posx-i, posy-i, nb);
      i := i + 1;
      if (posx-i < 0) or (posy-i<0) then break;
    end;
  end;

  IF(nb>=4)THEN Result := True
           else result := false;
END;

{------------------------------------------------------------------------------
  TEST DIAGONAL 2 (/)
-------------------------------------------------------------------------------}
FUNCTION TestDiag2(posx,posy:Byte; curcolor:TColor; NbLigne, NbColonne:Byte):Boolean;
VAR nb,i:Byte;
BEGIN
  nb := 1;
  // Compte le nombre de jeton ayant la meme couleur dans le sans descendent
  if (posy < NbLigne-1) and (posx > 0) then
  begin
    i := 1;
    while (frmmain.GetCouleurJeton(posx-i,posy+i) = curcolor) do
    begin
      nb := nb + 1;
      frmmain.SauvegardeAlignement(posx-i, posy+i, nb);
      i := i + 1;
      if (posy+i > NbLigne - 1) or (posx-i<0) then break;
    end;
  end;
  // Compte le nombre de jeton ayant la meme couleur dans le sens montant
  if (posy>0) and (posx< NbColonne-1) then
  begin
    i := 1;
    while (frmmain.GetCouleurJeton(posx+i,posy-i) = curcolor) do
    begin
      nb:=nb+1;
      frmmain.SauvegardeAlignement(posx+i, posy-i, nb);
      i := i + 1;
      if (posx+i > NbColonne-1) or (posy-i<0) then break;
    end;
  end;

  IF(nb>=4)THEN Result := True
           else result := false;
END;

END.
